#include <CtrlLib/CtrlLib.h>

using namespace Upp;

struct TimerCallBackVariation : TopWindow
{

	Vector<int> interval;
	dword prev, now;

	TimeCallback timer, process;
	int timerDelay, processDelay;
	LineEdit le1;
	String Result;

	void Timer()
	{
		now = GetTickCount();
		interval.Add ( now - prev );
		prev = now ;
	}


	void Process()
	{
		timer.Kill();

		Result << "Count - " << interval.GetCount() << "\n";
		Result << "Interval Vector - " << interval << "\n" ;

		Sort ( interval );

		Result << "Sorted - " << interval << "\n";

		VectorMap<int, int> hist;
		int j, k;

		for ( int i = 0; i < interval.GetCount(); i++ )
		{
			j = interval[i];
			k = hist.Find ( j );

			if ( k > -1 )
			{
				hist[k] = hist[k] + 1;
			}

			else
			{
				hist.Add ( j, 1 );
			}
		}
		
		Result << "\nTimer Delay " << timerDelay << "\n";

		Result << "Time  \tCount" "\n";

		for ( int i = 0; i < hist.GetCount(); i++ )
		{
			Result << hist.GetKey ( i ) << "  \t" << hist.GetValues() [i] << "\n";
		}

		this->Title ( "Done" );
		le1.Paste(Result.ToWString());
	}

	TimerCallBackVariation()
	{
		timerDelay = -38;
		processDelay = 10000;
		Title ( "Timer Callback Time Variation" ).Zoomable().Sizeable();
		Add(le1);
		le1.SizePos();
		prev = GetTickCount();
		timer.Set ( timerDelay, [=] {Timer();} );
		process.Set ( processDelay, [=] { Process();} );
	}

};

GUI_APP_MAIN
{
	TimerCallBackVariation app;
	app.Run();
}
